org.apache.hc.core5.http.nio.entity

## Class DigestingEntityConsumer<T>

- java.lang.Object
- - org.apache.hc.core5.http.nio.entity.DigestingEntityConsumer<T>

- All Implemented Interfaces:
    AsyncDataConsumer, AsyncEntityConsumer<T>, ResourceHolder

      public class DigestingEntityConsumer<T>
      extends Object
      implements AsyncEntityConsumer<T>

  `AsyncEntityConsumer` decorator that calculates a digest hash from the data stream content and keeps the list of trailers received with the data stream.
  Since:
    5.0

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DigestingEntityConsumer(String algo, AsyncEntityConsumer<T> wrapped)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `consume(ByteBuffer src)` Triggered to pass incoming data to the data consumer.
    `void` | `failed(Exception cause)` Triggered to signal a failure in data processing.
    `T` | `getContent()` Returns the result of entity processing when it becomes available or `null` if the entity is still being received.
    `byte[]` | `getDigest()` Returns digest hash.
    `List<Header>` | `getTrailers()` List of trailers sent with the data stream.
    `void` | `releaseResources()`
    `void` | `streamEnd(List<? extends Header> trailers)` Triggered to signal termination of the data stream.
    `void` | `streamStart(EntityDetails entityDetails, FutureCallback<T> resultCallback)` Signals beginning of an incoming request entity stream.
    `void` | `updateCapacity(CapacityChannel capacityChannel)` Triggered to signal ability of the underlying data stream to receive data capacity update.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DigestingEntityConsumer

          public DigestingEntityConsumer(String algo,
                                         AsyncEntityConsumer<T> wrapped)
                                  throws NoSuchAlgorithmException

      Throws:
        `NoSuchAlgorithmException`

  - ### Method Detail

    - #### streamStart

          public void streamStart(EntityDetails entityDetails,
                                  FutureCallback<T> resultCallback)
                           throws IOException,
                                  HttpException

      Description copied from interface: `AsyncEntityConsumer`
      Signals beginning of an incoming request entity stream.
      Specified by:
        `streamStart` in interface `AsyncEntityConsumer<T>`
      Parameters:
        `entityDetails` - the details of the incoming message entity.
        `resultCallback` - the result callback.
      Throws:
        `IOException`
        `HttpException`

    - #### updateCapacity

          public void updateCapacity(CapacityChannel capacityChannel)
                              throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal ability of the underlying data stream to receive data capacity update. The data consumer can choose to write data immediately inside the call or asynchronously at some later point.
      Specified by:
        `updateCapacity` in interface `AsyncDataConsumer`
      Parameters:
        `capacityChannel` - the channel for capacity updates.
      Throws:
        `IOException`

    - #### consume

          public void consume(ByteBuffer src)
                       throws IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to pass incoming data to the data consumer. The consumer must consume the entire content of the data buffer. The consumer must stop incrementing its capacity on the capacity channel if it is unable to accept more data. Once the data consumer has handled accumulated data or allocated more intermediate storage it can update its capacity information on the capacity channel.
      Specified by:
        `consume` in interface `AsyncDataConsumer`
      Parameters:
        `src` - data source.
      Throws:
        `IOException`

    - #### streamEnd

          public void streamEnd(List<? extends Header> trailers)
                         throws HttpException,
                                IOException

      Description copied from interface: `AsyncDataConsumer`
      Triggered to signal termination of the data stream.
      Specified by:
        `streamEnd` in interface `AsyncDataConsumer`
      Parameters:
        `trailers` - data stream trailers.
      Throws:
        `HttpException`
        `IOException`

    - #### failed

          public void failed(Exception cause)

      Description copied from interface: `AsyncEntityConsumer`
      Triggered to signal a failure in data processing.
      Specified by:
        `failed` in interface `AsyncEntityConsumer<T>`
      Parameters:
        `cause` - the cause of the failure.

    - #### getContent

          public T getContent()

      Description copied from interface: `AsyncEntityConsumer`
      Returns the result of entity processing when it becomes available or `null` if the entity is still being received.
      Specified by:
        `getContent` in interface `AsyncEntityConsumer<T>`
      Returns:
        the response processing result.

    - #### releaseResources

          public void releaseResources()

      Specified by:
        `releaseResources` in interface `ResourceHolder`

    - #### getTrailers

          public List<Header> getTrailers()

      List of trailers sent with the data stream.
      Returns:
        the list of trailers sent with the data stream

    - #### getDigest

          public byte[] getDigest()

      Returns digest hash.
      Returns:
        the digest hash value.

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.